;******************************************************
;   Date:               mart 2009
;   File Version:       2.7
;   Assembler:          mpasm  7.42
;   Author:             Bogdanov Andrew
;******************************************************
mov     macro   metka1,metka2      ;  2->1
        movf    metka2,w           ;
        movwf   metka1             ;
        endm                       ;
mvi     macro   metka1,constant    ;  constant->1
        movlw   constant           ;
        movwf   metka1             ;
        endm                       ;
ret     macro                      ; 
        return                     ;
        endm                       ;
cz      macro   metka              ;  
        btfsc   STATUS,2           ;  - = 0
        call    metka              ;
        endm                       ;
cnz     macro   metka              ;  
        btfss   STATUS,2           ;  - = 0
        call    metka              ;
        endm                       ;
rz      macro                      ;  
        btfsc   STATUS,2           ;  
        return                     ; ,  - = 0
        endm                       ;
rnz     macro                      ;  
        btfss   STATUS,2           ;  
        return                     ; ,  -  = 0
        endm                       ;
rnc     macro                      ;  
        btfsc   STATUS,0           ;  - > 0
        return                     ;
        endm                       ;
rc      macro                      ;  
        btfss   STATUS,0           ;  - < 0
        return                     ;
        endm                       ;
cmp     macro   metka2,metka1      ;  1  2
        movf    metka2,w           ; f-w
        subwf   metka1,w           ;
        endm                       ;
cpi     macro   metka2,metka1      ;  2  
        movf    metka2,w           ; k-w
        sublw   metka1             ;
        endm                       ;
and     macro   metka2,metka1      ; and F  
        movlw   metka1             ;
        andwf   metka2,f           ;
        endm                       ;
ori     macro   metka2,metka1      ; and F  
        movlw   metka1             ;
        iorwf   metka2,f           ;
        endm                       ;
;************************************************************
fcall0    macro   metka              ; FAR  
          lcall   metka              ;    0
          BCF     PCLATH,3
          BCF     PCLATH,4
          endm
fcall00   macro   metka              ; FAR  
          lcall   metka              ;    0
          BCF     PCLATH,3
          BCF     PCLATH,4
          endm
;************************************************************
; RAM    
;************************************************************
page0   macro                      ;   0
        bcf     STATUS,5
        bcf     STATUS,6
        endm
page1   macro                      ;   1
        bsf     STATUS,5
        bcf     STATUS,6
        endm
page2   macro                      ;   2
        bcf     STATUS,5
        bsf     STATUS,6
        endm
page3   macro                      ;   3
        bsf     STATUS,5
        bsf     STATUS,6
        endm
;***********************************************************************
pageFsr0  macro                    ;   0
        bcf     FSR,7
        bcf     STATUS,7
        endm
pageFsr1   macro                   ;   1
        bsf     FSR,7
        bcf     STATUS,7
        endm
pageFsr2   macro                   ;   2
        bcf     FSR,7
        bsf     STATUS,7
        endm
pageFsr3   macro                   ;   3
        bsf     FSR,7
        bsf     STATUS,7
        endm
;************************************************************
W           equ        0           ;   
F           equ        1           ;   
;******************** Flag bits: ****************************
C           equ        0           ;  - Carry
CR          equ        0           ;  - Carry
Z           equ        2           ; Zero
ZR          equ        2           ; Zero
RP0         equ        5           ;  0-1
RP1         equ        6           ;  01-23
;************************************************************
TempReg71_74 macro         ;  
temp_s      equ   0x71     ;  
temp_w      equ   0x72     ;
temp_fsr    equ   0x73     ;    
temp_pc     equ   0x74     ;
            endm
;************************************************************
PUSH    macro                  ; c  PUSH
        movwf   temp_w         ;  W
        swapf   STATUS,w       ;  Status
        movwf   temp_s         ;
        movf    FSR,w          ;  fsr
        movwf   temp_fsr       ;
        mov     temp_pc,PCLATH ;  PCLATH
        clrf    PCLATH         ;      0
        clrf    STATUS         ;  0
        endm                   ;  
POP     macro                  ; 
        movf    temp_fsr,w     ;
        movwf   FSR            ; return fsr
        mov     PCLATH,temp_pc ;  PCLATH
        swapf   temp_s,w       ; c  POP
        movwf   STATUS         ;  Status
        swapf   temp_w,f       ;  W 
        swapf   temp_w,w       ;   Z !
        retfie  ;       
        endm                   ;  
;******************************************************
      __CONFIG b'00001100000110' ;   628 
;************** Bank 0 **************************************
INDF        equ        00h         ;     FSR
TMR0        equ        01h         ; TMR0
PC          equ        02h         ;  
STATUS      equ        03h         ; Status
FSR         equ        04h         ;   
PORTA       equ        05h         ; Port A
PORTB       equ        06h         ; Port B
PCLATH      equ        0Ah         ;   PC
INTCON      equ        0Bh         ;  
PIR1        equ        0Ch         ;
TMR1L       equ        0Eh         ;
TMR1H       equ        0Fh         ;
T1CON       equ        10h         ;
TMR2        equ        11h         ;
T2CON       equ        12h         ;
CCPR1L      equ        15h         ;
CCPR1H      equ        16h         ;
CCP1CON     equ        17h         ;
RCSTA       equ        18h         ;
TXREG       equ        19h         ;
RXREG       equ        1Ah         ;
RCREG       equ        1Ah         ;
CMCON       equ        1Fh         ;
;************** Bank 1 **************************************
OPTIONR     equ        01h         ; 81h  Option (RP0=1)
TRISA       equ        05h         ; 85h  Tris A - RP0=1
TRISB       equ        06h         ; 86h  Tris B - RP0=1
PIE1        equ        0Ch         ; 8Ch         - RP0=1
PCON        equ        0Eh         ; 8Eh         - RP0=1
PR2         equ        12h         ; 92h         - RP0=1
TXSTA       equ        18h         ; 98h         - RP0=1
SPBRG       equ        19h         ; 99Bh        - RP0=1
VRCON       equ        1Fh         ; 99Bh        - RP0=1
;************************************************************
EEDATA   equ   1Ah  ; EEPROM   .
EEADR    equ   1Bh  ; EEPROM 
EECON1   equ   1CH     ;
EECON2   equ   1Dh  ;  
WRERR    equ   3  ; bit EECON1 1=   
WREN     equ   2  ; bit EECON1 1= 
WRee     equ   1  ; bit EECON1 1= 0=  
RDee     equ   0  ; bit EECON1   1   
;************************************************************
GIE         equ        7           ;
;************************************************************
Init628       macro   ; 
              clrf        STATUS      ; c 0
              bsf         STATUS,RP0  ; c 1
              movlw       b'00000111' ; XT->Prescaler(1:256)->RTCC
              movwf       OPTIONR     ; +  
              clrf        VRCON       ; 628   
              clrf        PCON        ; 628
              clrf        STATUS      ; c 0
              mvi         CMCON,0x07  ; 628 port A in-out
              endm
;******************************************************
#define  ClkLine  PORTB,3  ; 9= 2   3
#define  DataLine PORTB,0  ; 6=data 2   0
#define  sdata    PORTB,7  ; 5 <-> data
#define  sclk     PORTB,6  ; 6 --> clock
;#define  CSled    PORTB,4  ; CS 2 -   LEDS!
#define  CSled    PORTA,3  ; CS 2 -   LEDS!
;    2-3  !!! 
;#define  KP2a   PORTA,1   ; 18
;#define  KP2b   PORTA,0   ; 17
;#define  KP2c   PORTA,2   ; 1
;*******************************************************
; tablo 1 = 20h-3Fh bank 1
; tablo 2 = 20h-3Fh bank 2
; tablo 3 = 20h-3Fh bank 3
;******************************************************
mFlags      equ  0x41  ;
#define  Fspec        mFlags,2  ;    
#define  Finv         mFlags,3  ;  
#define  FModeSpeed   mFlags,4  ;    - 
#define  FrecEnable   mFlags,5  ;    =1
;*******   ***********************************
mDelay       equ  0x42  ;
RepeatSP     equ  0x43  ;   
ModeExe      equ  0x44  ;    
mFlashLr     equ  0x47  ;   
mFlashHr     equ  0x48  ;  
mSpeed       equ  0x49  ;   
mFlashLzg    equ  0x4A  ;   
mFlashHzg    equ  0x4B  ;  
PosZG        equ  0x4C  ;   
mTipEffect   equ  0x4D  ;  
mTimeEffect  equ  0x4E  ;  
mSpecDOP     equ  0x4F  ;  
;---------------------------------
RxByte       equ  0x60  ;   
mTOut        equ  0x61  ;     
loops        equ  0x62  ; wait  
loops2       equ  0x63  ;
mCountEff    equ  0x64  ;     

mTmpUNI1     equ  0x6E  ;
mTmpUNI2     equ  0x6F  ;
;********************************************************
;******    70-7F ! ************************
datai       equ  0x70  ;   
;-----   2464 ------------------------------
eeprom      equ  0x72  ;  
#define  di       eeprom,7  ; eeprom input bit
#define  do       eeprom,6  ; eeprom output bit
bycnt       equ  0x73  ;      
txbuf       equ  0x74  ;  
countee     equ  0x75  ;  
bcount      equ  0x76  ;   
;*******************************************************
mCountDop   equ  0x77  ;
mNewSolb    equ  0x78  ;
mNewSimbol  equ  0x79  ;
;**********     *************************
temp_pc     equ  0x7C  ;  PCLATH
temp_s      equ  0x7D  ; \ Int  
temp_w      equ  0x7E  ; \
temp_fsr    equ  0x7F  ; \ Int    
;---------------------------------------------------------------
;     96 
Line96     macro   bit,Label1,Label2,Label3
;------------------------------------------
           bsf     STATUS,7
           mvi     FSR,0x3F     ; page 2
Label1:
           bcf     ClkLine      ;  2
           clrwdt               ; 
           bsf     DataLine     ; data 2
           btfss   INDF,bit     ;   
           bcf     DataLine     ; data 2
           decf    FSR,f        ;
           bsf     ClkLine      ;  2
           btfsc   FSR,5
           goto    Label1       ; 32 
;------------------------------------------
           clrf    STATUS
           mvi     FSR,0x3F+0x80; page 1
Label2:
           bcf     ClkLine      ;  2
           clrwdt               ; 
           bsf     DataLine     ; data 2
           btfss   INDF,bit     ;   
           bcf     DataLine     ; data 2
           decf    FSR,f        ;
           bsf     ClkLine      ;  2
           btfsc   FSR,5
           goto    Label2       ; 32 
;------------------------------------------
           mvi     FSR,0x3F     ; page 0
Label3:
           bcf     ClkLine      ;  2
           clrwdt               ; 
           bsf     DataLine     ; data 2
           btfss   INDF,bit     ;   
           bcf     DataLine     ; data 2
           decf    FSR,f        ;
           bsf     ClkLine      ;  2
           btfsc   FSR,5
           goto    Label3       ; 32 
;------------------------------------------
           endm
;************************************************************
CSonAndDelay macro  bits     ; 1-6-7-2-3-5-0-4
         clrf    STATUS      ;    0
         mvi     mDelay,.3   ;  
         call    Dcuc        ; 
         mvi     PORTA,bits  ;   + CS
         endm
;************************************************************
TrisOut   macro
          page1                   ; c 1
          bcf         sdata       ; data-clk OUT
          page0                   ; c 0
          endm
TrisIn    macro
          page1                   ; c 1
          bsf         sdata       ; data-clk IN
          page0                   ; c 0
          endm
;************************************************************
;*******************************************************
        ORG     0          ;  
;*******************************************************
        goto    Start      ;    
;*******************************************************
        ORG     4          ;  
;*******************************************************
        PUSH
        clrf    STATUS         ;
        mov     RxByte,RCREG   ;
;---------------------------------------------------------
        mvi     mTOut,.100     ;     
        incf    PORTA,f        ;  
        bcf     CSled          ;  
        bcf     DataLine       ; 0
        btfss   RxByte,3       ;   
        bsf     DataLine       ; 1
;---------------------------------------------------------
        cpi     RxByte,0xFF    ;
        bz      ToUstFlag      ; UST   
        btfss   Fspec          ;    
        goto    WriteData
;----------------------------------------------------------
ChangeSpec:
        bcf     Fspec          ;  
        cpi     RxByte,0xFE    ;
        bz      ToSimbFF       ;   FF
        cpi     RxByte,0xF1    ;
        bz      ToTxt          ;   
        cpi     RxByte,0xF0    ;
        bz      ToCoda         ;  
        cpi     RxByte,0xF6    ; 
        bz      ToZg           ;  
        cpi     RxByte,0xF8    ; 
        bz      ToZg           ;  
        goto    ret_int        ;   
;==========================================================
ToTxt:         ;   
        mvi     mFlashLr,0x01  ;  2- 
        mvi     mFlashHr,0x08  ;
        bsf     FrecEnable     ;    =1
        goto    ret_int        ;
;----------------------------------------------------------
ToZg:          ;  
        mvi     mFlashLr,0x00  ;
        mvi     mFlashHr,0x01  ; ZG   ROM
        bsf     FrecEnable     ;    =1
        goto    ret_int        ;
;----------------------------------------------------------
ToCoda:                        ;
        mvi     mTOut,.3       ; 7 =    
        mvi     RxByte,0x08    ;  
        call    WriteRx
        bcf     FrecEnable     ;    =1
        goto    ret_int
;----------------------------------------------------------
ToSimbFF:                      ;   FF
        mvi     RxByte,0xFF     ;  
WriteData:
        cpi     mFlashHr,0x00 ;   24c512
;        cpi     mFlashHr,0x20 ;  24c64
        bz      ToCoda
        call    WriteRx
;---------------------------------------------------------------
        incf    mFlashLr,f    ;
        bnz     ret_int
        incf    mFlashHr,f
        goto    ret_int
;==========================================================
ToUstFlag:      ; UST   
        bsf     Fspec          ;   
ret_int:
        bcf     PIR1,5         ; USART -  !!!
        POP
;*********************************************************
Start:
;*********************************************************
            page1                   ; c 1
            movlw       b'10000011' ; HS->Prescaler->Timer0,
            movwf       OPTIONR     ; 1:16
            movlw       b'11110000' ;
            movwf       TRISA       ;
           movlw       b'00110010' ; TX=2   628
            movwf       TRISB       ;
           clrf        VRCON       ; 628   
           clrf        PCON        ; 628
;*********************************************************
            movlw       d'207'      ; 1.200 (207=16Mhz)  brg=0
            movwf       SPBRG       ; USART  DMX512-
            movlw       b'00100000' ;  
            movwf       PIE1        ; USART
            movlw       b'00100010' ; 8 , TX=on, BRGH=0
            movwf       TXSTA       ; USART
            clrf        STATUS
;*********************************************************
            mvi         CMCON,0x07  ; 628 port A in-out
            mov         RxByte,RCREG;
            mov         RxByte,RCREG;
            movlw       b'10010000' ; TX,RX=on, 8 
            movwf       RCSTA       ; USART
            clrf        PIR1        ; USART -  !!!
            movlw       b'11000000' ;  
            movwf       INTCON      ; 
;//////////////////////////////////////////////////////////
            bsf         FrecEnable  ;    =1
        clrf    mFlashLr       ;  
        mvi     mFlashHr,0x08  ;
        mvi     RxByte,.32     ;  
        call    WriteRx
        call    waitRec24cXX   ;  
            bcf         FrecEnable  ;    =1
;//////////////////////////////////////////////////////////
NewLoad:
        clrwdt                 ;  WDT 
        call    ClearAll       ;
        clrf    mFlashLr       ;  
        mvi     mFlashHr,0x08  ;
        clrf    mTOut          ;     
        clrf    PosZG          ;
        bsf     FModeSpeed     ; 0 -  
        mvi     mSpeed,.4      ; 0-7 = 8   0-
        bcf     Finv           ;   
;*********************************************************
BaseCucSymbol:
;*********************************************************
;---------------------------------------------------------
       ;     
;---------------------------------------------------------
        cpi     mTOut,0        ;     
        bz      NoReceiv       ;
        cpi     mTOut,1        ;     
        bz      NewLoad        ;
        decf    mTOut,f        ;
        mvi     mDelay,.250    ; 
        bcf     ClkLine        ;  
        call    Dcuc           ; 
        bsf     ClkLine
        goto    BaseCucSymbol
NoReceiv:
;---------------------------------------------------------
;.........................................................
;       N 1
;.........................................................
         call    CSoffandDelay  ;      
         Line96  7,m7,m7a,m7b   ;   96 
         CSonAndDelay  6        ;   + CS
         call    DelaySpeed     ;   
;.........................................................
;       N 2
;.........................................................
        call    CSoffandDelay  ;      
        Line96  6,m6,m6a,m6b   ;   96 
        CSonAndDelay  7        ;   + CS
        call    DelaySpeed     ;   
;.........................................................
;       N 3
;.........................................................
        call    CSoffandDelay  ;      
        Line96  5,m5,m5a,m5b   ;   96 
        CSonAndDelay  2        ;   + CS
        call    DelaySpeed     ;   
;.........................................................
;       N 4
;.........................................................
        call    CSoffandDelay  ;      
        Line96  4,m4,m4a,m4b   ;   96 
        CSonAndDelay  3        ;   + CS
        call    DelaySpeed     ;   
;.........................................................
;       N 5
;.........................................................
        call    CSoffandDelay  ;      
        Line96  3,m3,m3a,m3b   ;   96 
        CSonAndDelay  5        ;   + CS
        call    DelaySpeed     ;   
;.........................................................
;       N 6
;.........................................................
        call    CSoffandDelay  ;      
        Line96  2,m2,m2a,m2b   ;   96 
        CSonAndDelay  0        ;   + CS
        call    DelaySpeed     ;   
;.........................................................
;       N 7
;.........................................................
        call    CSoffandDelay  ;      
        Line96  1,m1,m1a,m1b   ;   96 
        CSonAndDelay  4        ;   + CS
        call    DelaySpeed     ;   
;.........................................................
;       N 8
;.........................................................
        call    CSoffandDelay  ;      
        Line96  0,m0,m0a,m0b   ;   96 
        CSonAndDelay  1        ;   + CS
        call    DelaySpeed     ;   
;=========================================================
;---------------------------------------------------------
;`           
;---------------------------------------------------------
        cpi     mTipEffect,0
        bnz     NoJobStroka
        call    ReadNewSimbol  ; out: mNewSimbol
;---------------------------------------------------------
;=========================================================
;---------------------------------------------------------
;        
;---------------------------------------------------------
        cpi     mNewSimbol,'/' ; >   ?
        bnz     NoEffekt       ;  
        clrf    mCountDop      ;
        clrf    mCountEff      ;   
        call    incADDRsimbol  ;  
        call    ReadNewSimbol  ;   
        mov     mTipEffect,mNewSimbol
        call    UstModeEffect  ;   
        call    incADDRsimbol  ;  
        call    ReadNewSimbol  ;   
;        cpi     mNewSimbol,'8' '9'  ;  
;        bz                            = 0
        movlw   0x30          ; 30 -> 37
        subwf   mNewSimbol,f
        movlw   0x07          ;  0 -> 7
        andwf   mNewSimbol,f
;        cpi     mTipEffect,'L'      ; 
;        bz      UstSpeedLow         ; 
        cpi     mTipEffect,'s'      ; 
        bz      UstSpeedQwylle      ; 
        cpi     mTipEffect,'S'      ; 
        bz      UstSpeedQwylle      ; 
        swapf   mNewSimbol,w        ;
        movwf   mTimeEffect         ;   16
        movlw   0xF0                ;  50  250
        andwf   mTimeEffect,f       ; 
        movlw   .50
        addwf   mTimeEffect,f
        mvi     mNewSimbol,.32      ;   008
        goto    OutEffekt           ;   
;---------------------------------------------------------
UstSpeedLow:
        bcf     FModeSpeed     ;   
        comf    mNewSimbol,w   ;
        movwf   mSpeed         ;
        movlw   0x07           ;
        andwf   mSpeed,f       ;
        clrf    mTipEffect     ;  
        goto    OutEffekt      ;   
;---------------------------------------------------------
UstSpeedQwylle:
        bsf     FModeSpeed     ;   
        comf    mNewSimbol,w   ;
        movwf   mSpeed         ;
        movlw   0x07           ;
        andwf   mSpeed,f       ;
        clrf    mTipEffect     ;  
        goto    OutEffekt      ;   
;---------------------------------------------------------
OutEffekt:
        call    incADDRsimbol  ;  
        call    ReadNewSimbol  ;   
        clrf    PosZG          ;   
NoEffekt:
;=========================================================
;---------------------------------------------------------
;        
;---------------------------------------------------------
        cpi     mNewSimbol,0x08;   ?
        bnz     NormaOutZG     ;
        clrf    mFlashLr       ;  
        mvi     mFlashHr,0x08  ;  2- 
        mvi     mNewSimbol,.32 ;   008
;---------------------------------------------------------
NormaOutZG: ;    
;---------------------------------------------------------
        call    NewStolbFromZG ;in: mNewSimbol -> out: mNewSolb
        cpi     mNewSimbol,0xDB; - 
        bz      FollowPosZG    ;  
        cpi     mNewSimbol,0xFB;    
        bz      FollowPosZG    ;
        cpi     mNewSimbol,.32 ;    
        bz      FollowPosZG    ;
        cpi     PosZG,2        ;     
        bc      FollowPosZG    ;  3- 
        cpi     mNewSolb,0     ;
        bz      MadeNewSimbol
FollowPosZG:
        incf    PosZG,f        ;   
        cpi     PosZG,8        ;  ZG = 8x8
        bnz     ObxodZG        ;   
MadeNewSimbol:
        clrf    PosZG          ;   
        call    incADDRsimbol  ;    
ObxodZG:
        btfsc   Finv           ;   
        comf    mNewSolb,f     ; 
;=========================================================
NoJobStroka:
;---------------------------------------------------------
;     
;     
;---------------------------------------------------------
        btfsc   FModeSpeed     ;   
        goto    NoModeSpeedLow ; 0 -  
        incf    RepeatSP,f     ;
        mov     bcount,mSpeed  ; 0 -> 7 = 8 
        rlf     bcount,f       ;   
        bcf     bcount,0       ;   
        movlw   .21            ; output = (input * 2) + 21
        addwf   bcount,f       ; 21 -> 37
        cmp     RepeatSP,bcount; 30=4   
        bnz     BaseCucSymbol  ; 20 = min  
        clrf    RepeatSP       ; real 20-50
NoModeSpeedLow:
;---------------------------------------------------------
;=========================================================
;---------------------------------------------------------
;       ;  
;---------------------------------------------------------
        cpi     mTipEffect,'D' ;   
        bz      ExeDown
        cpi     mTipEffect,'d' ;   
        bz      ExeDown
        cpi     mTipEffect,'U' ;   
        bz      ExeUp
        cpi     mTipEffect,'u' ;   
        bz      ExeUp
        cpi     mTipEffect,'J' ;  
        bz      ExeLeftRight
        cpi     mTipEffect,'j' ;  
        bz      ExeLeftRight
        cpi     mTipEffect,'W' ;   
        bz      ExeWait
        cpi     mTipEffect,'w' ;   
        bz      ExeWait
        cpi     mTipEffect,'F' ;   FF
        bz      ExeFill
        cpi     mTipEffect,'f' ;   FF
        bz      ExeFill
        clrf    mTipEffect     ;  
        call    SdwigRamStrokiLeft  ;   
        goto    BaseCucSymbol  ;
;---------------------------------------------------------
ExeDown:
        incf    mCountDop,f    ;
        cpi     mCountDop,.3   ;
        bnz     BaseCucSymbol  ;
        clrf    mCountDop      ;
        call    CucDown
        incf    mCountEff,f     ;  -
        cpi     mCountEff,.10  ;  
        bnz     BaseCucSymbol  ;
        clrf    mTipEffect     ;  
        goto    BaseCucSymbol  ;
;---------------------------------------------------------
ExeUp:
        incf    mCountDop,f    ;
        cpi     mCountDop,.3   ;
        bnz     BaseCucSymbol  ;
        clrf    mCountDop      ;
        call    CucUP
        incf    mCountEff,f    ;  -
        cpi     mCountEff,.10  ;  
        bnz     BaseCucSymbol  ;
        clrf    mTipEffect     ;  
        goto    BaseCucSymbol  ;
;---------------------------------------------------------
ExeLeftRight:
        call    CheckRazdvig   ;  
        incf    mCountEff,f    ;  -
        cpi     mCountEff,.50  ;  
        bnz     BaseCucSymbol  ;
        clrf    mTipEffect     ;  
        goto    BaseCucSymbol  ;
;---------------------------------------------------------
ExeWait:
        decf    mTimeEffect,f
        bnz     BaseCucSymbol
        clrf    mTipEffect     ;  
        goto    BaseCucSymbol  ;
;---------------------------------------------------------
ExeFill:
        mvi     mNewSolb,0xFF  ;
        call    SdwigRamStrokiLeft  ;   
        incf    mCountEff,f    ;  -
        cpi     mCountEff,.96  ;  
        bnz     BaseCucSymbol  ;
        clrf    mTipEffect     ;  
        goto    BaseCucSymbol  ;
;*********************************************************
;*********************************************************
;*********************************************************
; / -  Y R G
; /R -     
; /Z -    ,   
; /I - 
; /N -  , 
; /Q - (qwikle)  t 
; /U - (up)   (in move=stop news)
; /D - (down)   (in move=stop news)
; /J - (J)     (in move=stop news)
; /F - (fill)  ,   
; /A - (Add)  ,   
; /S - (speed)   
;     3-  ,       
; /W - (wait)     N-
;     3-    ,     = 1 
;---------------------------------------------------------
UstModeEffect:  ;   
;---------------------------------------------------------
;        cpi     mSpec,'Z'     ;   
;        bz      EffectsXaos
        cpi     mTipEffect,'I' ;  
        bz      EffectsInvers  ;
        cpi     mTipEffect,'i' ;  
        bz      EffectsInvers  ;
        cpi     mTipEffect,'N' ;  
        bz      EffectsNorma   ;
        cpi     mTipEffect,'n' ;  
        bz      EffectsNorma   ;
        cpi     mTipEffect,'Q' ;   
        bz      EffectsQUKLY
        cpi     mTipEffect,'q' ;   
        bz      EffectsQUKLY
        cpi     mTipEffect,'D' ;   
        rz
        cpi     mTipEffect,'U' ;   
        rz
        cpi     mTipEffect,'J' ;  
        rz
        cpi     mTipEffect,'W' ;   
        rz
        cpi     mTipEffect,'F' ;   FF
        rz
        cpi     mTipEffect,'S' ;  - 
        rz
;        cpi     mTipEffect,'L' ;  - 
;        rz
        return
;=========================================================
EffectsInvers:
;=========================================================
        bsf     Finv
        clrf    mTipEffect     ;  
        return
;=========================================================
EffectsNorma:
;=========================================================
        bcf     Finv
        clrf    mTipEffect     ;  
        return
;=========================================================
EffectsQUKLY:   ;   
;=========================================================
        call    ClearTablo     ;
        mvi     mTipEffect,'W'
        return
;********************************************************
CucUP:
;********************************************************
        clrf    mSpecDOP
UP0:
        mvi     FSR,0x20       ;
        pageFsr0               ;  . 
        movf    mSpecDOP,w     ;
        addwf   FSR,f          ;
        rrf     INDF,f         ;
        bcf     INDF,7
        incf    mSpecDOP,f     ;
        cpi     mSpecDOP,.32   ;
        bnz     UP0
;--------------------------------------------------------
        clrf    mSpecDOP
UP1:
        mvi     FSR,0x20       ;
        pageFsr1               ;  . 
        movf    mSpecDOP,w     ;
        addwf   FSR,f          ;
        rrf     INDF,f         ;
        bcf     INDF,7
        incf    mSpecDOP,f     ;
        cpi     mSpecDOP,.32   ;
        bnz     UP1
;--------------------------------------------------------
        clrf    mSpecDOP
UP2:
        mvi     FSR,0x20       ;
        pageFsr2               ;  . 
        movf    mSpecDOP,w     ;
        addwf   FSR,f          ;
        rrf     INDF,f         ;
        bcf     INDF,7
        incf    mSpecDOP,f     ;
        cpi     mSpecDOP,.32   ;
        bnz     UP2
;--------------------------------------------------------
        clrf    STATUS
        return
;********************************************************
CucDown:
;********************************************************
        clrf    mSpecDOP
DownOneBank00:
        mvi     FSR,0x20       ;
        pageFsr0               ;  . 
        movf    mSpecDOP,w     ;
        addwf   FSR,f          ;
        rlf     INDF,f         ;
        bcf     INDF,0
        incf    mSpecDOP,f     ;
        cpi     mSpecDOP,.32   ;
        bnz     DownOneBank00  ;
;--------------------------------------------------------
        clrf    mSpecDOP
DownTwoBank00:
        mvi     FSR,0x20       ;
        pageFsr1               ;  . 
        movf    mSpecDOP,w     ;
        addwf   FSR,f          ;
        rlf     INDF,f         ;
        bcf     INDF,0
        incf    mSpecDOP,f     ;
        cpi     mSpecDOP,.32   ;
        bnz     DownTwoBank00  ;
;--------------------------------------------------------
        clrf    mSpecDOP
DownTwoBank020:
        mvi     FSR,0x20       ;
        pageFsr2               ;  . 
        movf    mSpecDOP,w     ;
        addwf   FSR,f          ;
        rlf     INDF,f         ;
        bcf     INDF,0
        incf    mSpecDOP,f     ;
        cpi     mSpecDOP,.32   ;
        bnz     DownTwoBank020  ;
;--------------------------------------------------------
        clrf    STATUS
        return
;/////////////////////////////////////////////////////
;****************************************************************
;**************************************************************
BSTART:   ;     
;**************************************************************
         bsf     sdata   ; data -> 1
         TrisOut         ;  r data  clock  
         bcf     sclk    ; clock -> 0
         nop
         nop
         nop
         bsf     sclk    ; clock -> 1
         nop
         nop
         clrwdt          ;  WDT 
         nop
         nop
         bcf     sdata   ;    data  -> 0
         nop             ; clock -> 1
         nop
         nop
         nop
         nop             ; 
         bcf     sclk    ;   
         nop
         nop
         retlw   0
;************************************************************
BSTOP:    ;     
;**************************************************************
         bcf     sdata   ; data -> 0
         TrisOut         ;  r data  clock  
         bcf     sdata   ; clock -> 0
         nop
         nop
         nop
         bsf     sclk    ; clock -> 1
         nop
         clrwdt          ;  WDT 
         nop
         bsf     sdata   ; data -> 1
         nop
         nop             ;   
         nop
         bcf     sclk    ; clock -> 0
         nop
         nop
         nop             ;   
         bsf     sclk    ;  .1
         retlw   0
;*************************************************************
BITOUT:                  ;   
;**************************************************************
         TrisOut         ;  r data  clock  
         btfss   do      ;    data
         goto    bitlow  ; 0 ?    0
         bsf     sdata   ; 1 ? data -> 1
         goto    clkout  ;     
;-------------------------------------------------------------
bitlow   bcf     sdata   ; data -> 0
         nop
clkout   bsf     sclk    ; clock -> 1
         nop
         nop
         clrwdt          ;  WDT 
         nop
         bcf     sclk    ; clock -> 0
         retlw   0
;**************************************************************
BITIN:                   ;   
;**************************************************************
         bsf     di      ;   bit -> 1
         TrisIn          ;   clock  
; >>>>>  bsf     sdata   ; sdata  
         bsf     sclk    ; clock -> 1
         nop             ; 
         nop
         clrwdt          ;  WDT 
         nop
         nop             ;
         btfss   sdata   ;  data bit
         bcf     di      ;  bit ->0,'di' 
         bcf     sclk    ; clock -> 0
         retlw   0       ;
;****************************************************************
TX24c64:   ;    'datao'
;****************************************************************
         movlw   .8         ;   
         movwf   countee    ;    = 8
TXLP:                       ;
         bcf     do         ;     = 0
         btfsc   txbuf,7    ; bit = 0 ?
         bsf     do         ; ,  = 1
         call    BITOUT     ;    serial EE
         rlf     txbuf, F   ;    
         decfsz  countee,F  ;  8 bit ?
         goto    TXLP       ;  - 
         call    BITIN      ;  ack bit
         retlw   0          ;
;****************************************************************
RX24c64:  ;     'datai'    .
;****************************************************************
         clrf    datai          ;  input buffer
         movlw   .8             ;    = 8
         movwf   countee
         bcf    STATUS,CR       ;
RXLP:    rlf     datai,F        ;  datai  1 
         call    BITIN          ;  bit
         btfsc   di
         bsf     datai,0        ;  bit 0  
         decfsz  countee, F       ;  8 bit ?
         goto    RXLP           ;  - 
         bsf     do             ;  ack bit = 1
         call    BITOUT         ;  
         retlw   0
;*********************************************************
WriteRx:
;*********************************************************
         btfss   FrecEnable  ;    =1
         return
         call    BSTART      ;   start bit
      movlw   b'10100000'    ;     
      movwf   txbuf          ;   
      call    TX24c64        ;  
         movf    mFlashHr,w  ;  
         movwf   txbuf       ;   
         call    TX24c64     ;  
      movf    mFlashLr,w     ;  
      movwf   txbuf          ;   
      call    TX24c64        ;  
         movf    RxByte,w    ;  
         movwf   txbuf       ;   
         call    TX24c64     ;  
         call    BSTOP       ;  stop bit
         return
;*************************************************************
waitRec24cXX:;  
;*************************************************************
         mvi     loops,.50
top:     movlw   .110       ;   
         movwf   loops2
top2:    nop                ; 
         nop
         nop
         clrwdt             ;  WDT 
         nop
         nop
         decfsz  loops2, F  ;     ?
         goto    top2       ;  , 
                            ;
         decfsz  loops, F   ;     ?
         goto    top        ;  , 
         retlw   0          ; , 
;****************************************************************
;****************************************************************
;////////////////////////////////////////////////////////////////
;****************************************************************
;****************************************************************
;****************************************************************
DelaySpeed:
;****************************************************************
        btfss   FModeSpeed    ; 0 -  
        goto    Delay255      ; 0-7 = 8 
        mov     bcount,mSpeed ;
        movlw   5             ;
        addwf   bcount,f      ; 0-7 -> 4-12
DelaySpeedCuc:
        call    Delay255
        decfsz  bcount,f
        goto    DelaySpeedCuc
        return
;*******************************************************
Delay255:
;*******************************************************
        mvi     mDelay,.255   ;
        goto    Dcuc
;*******************************************************
Dcuc:
;*******************************************************
        clrwdt
        decfsz    mDelay,f
        goto      Dcuc
        return
;*******************************************************
ClearREG: ;     
;*******************************************************
           mvi     bcount,.97
           bcf     DataLine     ; data 2
CucReg:
           bcf     ClkLine      ;  2
           clrwdt               ; 
           bsf     ClkLine      ;  2
           decfsz  bcount,f     ;
           goto    CucReg       ;
           return
;*******************************************************
CSoffandDelay:  ;      
;*******************************************************
         clrf    STATUS      ;    0
         bsf     CSled       ;   
         mvi     mDelay,.55  ;  
         goto    Dcuc        ; 
;*********************************************************
CheckRazdvig:  ;  
;*********************************************************
        clrf    STATUS
        mvi     FSR,0x20   ;
        pageFsr0           ;  . 
Checkrz0:    ;
        incf    FSR,f      ;
        movf    INDF,w     ;   
        decf    FSR,f      ;
        movwf   INDF       ;    
        incf    FSR,f      ;
        cpi     FSR,0x3f   ;
        bnz     Checkrz0
;------------------------------------------------------
        clrf    STATUS
        bsf     STATUS,5   ; page 1
        movf    0x20,w
        clrf    STATUS     ; page 0
        movwf   0x3f
;------------------------------------------------------
        mvi     FSR,0x20+0x80   ; pageFsr1
r2dl1:    ;
        incf    FSR,f      ;
        movf    INDF,w     ;   
        decf    FSR,f      ;
        movwf   INDF       ;    
        incf    FSR,f      ;
        cpi     FSR,0xAf   ;
        bnz     r2dl1
;------------------------------------------------------
        page1
        mov     0x2F,mNewSolb ;     
;        clrf    0x2F       ;     
;======================================================
        clrf    STATUS
        mvi     FSR,0x3f   ;
        pageFsr2           ;  . 
Checkrz1:
        decf    FSR,f      ;
        movf    INDF,w     ;   
        incf    FSR,f      ;
        movwf   INDF       ;    
        decf    FSR,f      ;
        cpi     FSR,0x20   ;
        bnz     Checkrz1
;------------------------------------------------------
        page1
        movf    0x3F,w
        page2
        movwf   0x20
;------------------------------------------------------
        clrf    STATUS
        mvi     FSR,0x3f   ;
        pageFsr1           ;  . 
Checkrzw:
        decf    FSR,f      ;
        movf    INDF,w     ;   
        incf    FSR,f      ;
        movwf   INDF       ;    
        decf    FSR,f      ;
        cpi     FSR,0xB0   ;
        bnz     Checkrzw
;**************************************************************
        page1
        mov     0x30,mNewSolb;     
;       clrf    0x30       ;     
        clrf    STATUS
        return
;*******************************************************
SdwigRamStrokiLeft:  ;   
;*******************************************************
        clrf    STATUS
        mvi     FSR,0x20   ;
s2dl0:    ;
        incf    FSR,f      ;  W->W !!!
        movf    INDF,w     ;   
        decf    FSR,f      ;
        movwf   INDF       ;    
        incf    FSR,f      ;
        cpi     FSR,0x3f   ; btfss FSR,4 ???
        bnz     s2dl0      ; goto s2dl0
;------------------------------------------------------
        clrf    STATUS
        bsf     STATUS,5   ; page 1
        movf    0x20,w
        clrf    STATUS     ; page 0
        movwf   0x3f
;------------------------------------------------------
        mvi     FSR,0x20+0x80   ; pageFsr1
s2dl1:    ;
        incf    FSR,f      ;
        movf    INDF,w     ;   
        decf    FSR,f      ;
        movwf   INDF       ;    
        incf    FSR,f      ;
        cpi     FSR,0xDf   ;
        bnz     s2dl1
;------------------------------------------------------
        clrf    STATUS
        bsf     STATUS,6    ; page 2
        movf    0x20,w
        page1
        movwf   0x3f
        clrf    STATUS
;------------------------------------------------------
        mvi     FSR,0x20   ;
        pageFsr2           ;  . 
s2dl2:    ;
        incf    FSR,f      ;
        movf    INDF,w     ;   
        decf    FSR,f      ;
        movwf   INDF       ;    
        incf    FSR,f      ;
        cpi     FSR,0x3f   ;
        bnz     s2dl2
;------------------------------------------------------
        page2
        mov     0x3F,mNewSolb ;     
        clrf    STATUS
        return
;**************************************************
ClearTablo:
;**************************************************
; tablo 1 = 20h-3Fh bank 1
; tablo 2 = 20h-3Fh bank 2
; tablo 3 = 20h-3Fh bank 3
        clrwdt                 ;  WDT 
;---------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
        pageFsr0           ;  . 
clear_memT0:                ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x40   ;  = 0
        bnz     clear_memT0
;------------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
        pageFsr1           ;  . 
clear_memT1:                ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x40+0x80   ;  = 0
        bnz     clear_memT1
;---------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
        pageFsr2           ;  . 
clear_memT2:                ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x40   ;  = 0
        bnz     clear_memT2
;------------------------------------------------------
        clrwdt             ;  WDT 
        clrf    STATUS
        return
;******************************************************
ClearAll:
;******************************************************
        movlw   0x20       ; 
        movwf   FSR        ; 
        pageFsr0           ;  . 
clear_mem02:                ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x7f   ;  = 0
        bnz     clear_mem02
;------------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
        pageFsr1           ;  . 
clear_mem12:                ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0xff   ;  = 0
        bnz     clear_mem12
;------------------------------------------------------
        movlw   0x20       ; 
        movwf   FSR        ; 
        pageFsr2           ;  . 
clear_mem22:                ;
        clrf    INDF       ; 
        incf    FSR,f      ; ..   
        cpi     FSR,0x7f   ;  = 0
        bnz     clear_mem22
;------------------------------------------------------
        clrf    STATUS
        return
;******************************************************
incADDRsimbol:   ;    
;******************************************************
         incf    mFlashLr,f   ;
         rnz                  ;   
         incf    mFlashHr,f   ;
         cpi     mFlashHr,0x00;
         rnz                  ;   
         clrf    mFlashLr     ;  
         mvi     mFlashHr,0x08;  2- 
         return
;*********************************************************
ReadNewSimbol:               ;   
;*********************************************************
         call    BSTART      ;   
         movlw   b'10100000' ;     
         movwf   txbuf       ;    (write mode)
         call    TX24c64     ;   
      movf    mFlashHr,w     ;  
      movwf   txbuf          ;   
      call    TX24c64        ;  
         movf    mFlashLr,w  ;
         movwf   txbuf       ;   
         call    TX24c64     ;
      call    BSTART         ;  a   
         movlw   b'10100001' ;    (rd mode)
         movwf   txbuf       ;   
         call    TX24c64     ;   
         call    RX24c64     ;   1   serial EE
         call    BSTOP       ;   
      mov  mNewSimbol,datai  ;
         return
;*********************************************************
NewStolbFromZG:              ;    RAM
;*********************************************************
        mov     countee,mNewSimbol; 
        rlf     countee,f         ;  
        rlf     countee,f         ; 
        rlf     countee,w     ; 88
        movwf   mFlashLzg     ;   
        movlw   0xF8          ;  3  = 0
        andwf   mFlashLzg,f   ;  
        movf    PosZG,w       ;   
        addwf   mFlashLzg,f   ;   
;--------------------------------------------------------
        swapf   mNewSimbol,f  ;  3 
        rrf     mNewSimbol,w  ;
        andlw   0x07          ;  ZG
        movwf   mFlashHzg     ;   
;--------------------------------------------------------
         call    BSTART      ;   
         movlw   b'10100000' ;     
         movwf   txbuf       ;    (write mode)
         call    TX24c64     ;   
      mov    txbuf,mFlashHzg ;  
      call    TX24c64        ;  
         movf    mFlashLzg,w ;
         movwf   txbuf       ;   
         call    TX24c64     ;
      call    BSTART         ;  a   
         movlw   b'10100001' ;    (rd mode)
         movwf   txbuf       ;   
         call    TX24c64     ;   
         call    RX24c64     ;   1   serial EE
         call    BSTOP       ;   
      mov  mNewSolb,datai    ;
         return
;*************************************************************
 End ;   BrSoft Copyright (C) 2009 Bogdanov Andrew
;*************************************************************













